#include "stdafx.h"
#include "../ArchiverCode/Archiver7ZIP.h"
#include "ConfigManager.h"
#include "Config7Z.h"

void CConfig7Z::load(CONFIG_SECTION &Config)
{
	//vZbggǂ
	UsePreset=Config.Data[_T("UsePreset")].GetNParam(TRUE);
	//k`
	CompressType=(SEVEN_ZIP_COMPRESS_TYPE)Config.Data[_T("CompressType")].GetNParam(0,SEVEN_ZIP_COMPRESS_TYPE_LAST_ITEM,0);
	//kx
	CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)Config.Data[_T("CompressLevel")].GetNParam(0,SEVEN_ZIP_COMPRESS_LEVEL_LAST_ITEM,0);
	//LZMAk[h
	LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)Config.Data[_T("LZMAMode")].GetNParam(0,SEVEN_ZIP_LZMA_MODE_LAST_ITEM,0);
	//\bhk
	SolidMode=Config.Data[_T("SolidMode")].GetNParam(TRUE);
	//wb_k
	HeaderCompression=Config.Data[_T("HeaderCompression")].GetNParam(TRUE);
	//wb_Sk
	//FullHeaderCompression=Config.Data[_T("HeaderFullCompression")].GetNParam(TRUE);
	//wb_Í
	HeaderEncryption=Config.Data[_T("HeaderEncryption")].GetNParam(FALSE);

	//㋉ݒ
	//PPMd̃fTCYw肷邩ǂ
	SpecifyPPMdModelSize=Config.Data[_T("SpecifyPPMdModelSize")].GetNParam(FALSE);
	//PPMd̃fTCY
	PPMdModelSize=Config.Data[_T("PPMdModelSize")].GetNParam(SEVEN_ZIP_PPMD_MODEL_SIZE_LOWEST,SEVEN_ZIP_PPMD_MODEL_SIZE_HIGHEST,6);
}

void CConfig7Z::store(CONFIG_SECTION &Config)const
{
	//vZbggǂ
	Config.Data[_T("UsePreset")]=UsePreset;
	//k`
	Config.Data[_T("CompressType")]=CompressType;
	//kx
	Config.Data[_T("CompressLevel")]=CompressLevel;
	//LZMAk[h
	Config.Data[_T("LZMAMode")]=LZMA_Mode;
	//\bhk
	Config.Data[_T("SolidMode")]=SolidMode;
	//wb_k
	Config.Data[_T("HeaderCompression")]=HeaderCompression;
	//wb_Sk
	//Config.Data[_T("HeaderFullCompression")]=FullHeaderCompression;
	//wb_Í
	Config.Data[_T("HeaderEncryption")]=HeaderEncryption;

	//㋉ݒ
	//PPMd̃fTCYw肷邩ǂ
	Config.Data[_T("SpecifyPPMdModelSize")]=SpecifyPPMdModelSize;
	//PPMd̃fTCY
	Config.Data[_T("PPMdModelSize")]=PPMdModelSize;


	// pX[h֘A;݂̓pX[hpR[ĥ
	//w肳ꂽpX[hIɍ폜
	Config.Data.erase(_T("UseFixedPassword"));
	Config.Data.erase(_T("PasswordLength"));
	Config.Data.erase(_T("Password"));
}


void CConfig7Z::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("7Z")));
}

void CConfig7Z::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("7Z")));
	UtilDumpFlatConfig(ConfMan.GetSection(_T("7Z")).Data);
}

