#pragma once
#include "Dlg_Base.h"
#include "../../resource.h"
#include "../ConfigDLL.h"

class CConfigDialog;

//====================================
// DLL̗L/
//====================================
class CConfigDlgDLL : public CDialogImpl<CConfigDlgDLL>,public CMessageFilter,public CWinDataExchange<CConfigDlgDLL>,public IConfigDlgBase
{
protected:
	CConfigDLL m_Config;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_DLL };

#define MY_DDX_ENTRY(x)	DDX_CHECK(IDC_CHECK_ENABLE_##x,m_Config.EnableDLL[DLL_ID_##x])
	// DDX}bv
	BEGIN_DDX_MAP(CConfigDlgDLL)
		MY_DDX_ENTRY(UNLHA)
		MY_DDX_ENTRY(7ZIP)
		MY_DDX_ENTRY(CAB)
		MY_DDX_ENTRY(TAR)
		MY_DDX_ENTRY(JACK)
		MY_DDX_ENTRY(YZ1)
		MY_DDX_ENTRY(UNARJ)
		MY_DDX_ENTRY(UNGCA)
		MY_DDX_ENTRY(UNRAR)
		MY_DDX_ENTRY(UNACE)
		MY_DDX_ENTRY(UNIMP)
		MY_DDX_ENTRY(UNBEL)
		MY_DDX_ENTRY(UNHKI)
		MY_DDX_ENTRY(BGA)
		MY_DDX_ENTRY(AISH)
		MY_DDX_ENTRY(UNISO)
	END_DDX_MAP()
#undef MY_DDX_ENTRY

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgDLL)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnApply();

	CConfigDlgDLL(){}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

