#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverAISH.h"
#include "../ConfigAISH.h"

//====================================
// AISH̐ݒ荀
//====================================
class CConfigDlgAISH : public CDialogImpl<CConfigDlgAISH>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigAISH m_Config;

	CButton			Radio_EncodeType[ISH_ENCODE_TYPE_ITEM_COUNT];
	CButton			Check_UUEncodeChecksum;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_AISH };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgAISH)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

