#pragma once

class CJackVolumeSizeDialog : public CDialogImpl<CJackVolumeSizeDialog>,public CWinDataExchange<CJackVolumeSizeDialog>
{
protected:
public:
	int VolumeSize;
	enum {IDD = IDD_DIALOG_JACK_SPECIFY_VOLUME_SIZE};

	// DDX}bv
	BEGIN_DDX_MAP(CJackVolumeSizeDialog)
		DDX_INT(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS, VolumeSize)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CJackVolumeSizeDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl){
		if(!DoDataExchange(TRUE)){
			return;
		}
		if(VolumeSize<=0){
			::SetFocus(GetDlgItem(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS));
			::SendMessage(GetDlgItem(IDC_EDIT_JACK_VOLUME_SIZE_AT_COMPRESS),EM_SETSEL,0,-1);
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_VALUE_MUST_BE_PLUS)));
			return;
		}
		EndDialog(nID);
	}

	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl){
		EndDialog(nID);
	}
};

