#pragma once
#include "../resource.h"

class CWaitDialog : public CDialogImpl<CWaitDialog>,public CMessageFilter, public CIdleHandler
{
protected:
	CStatic	Static_MessageString;
	CStatic Static_Icon;
	std::vector<CIcon> m_IconArray;
	int m_CurrentIconNumber;
	DWORD m_LastTime;
	bool m_bAborted;
protected:
	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CMainDlg)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
		COMMAND_ID_HANDLER_EX(IDOK, __noop)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

    LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnDestroy();

	BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl){
		m_bAborted=true;
	}

	BOOL OnIdle(){
		return FALSE;
	}
public:
	enum {IDD = IDD_DIALOG_WAIT};
	void SetMessageString(LPCTSTR t){Static_MessageString.SetWindowText(t);}
	void AnimationCall();

	void Prepare(HWND,LPCTSTR);
	bool IsAborted(){return m_bAborted;}
};
