#include "stdafx.h"
#include "DropSource.h"
#include "../FileListModel.h"
//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.sakura.ne.jp/


HRESULT __stdcall CDropSource::QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState)
{
	// hbOp邩ǂ߂

	// ESCꂽꍇ}EX̃{^ꂽƂ͒~
	if(fEscapePressed || (MK_LBUTTON | MK_RBUTTON) == (grfKeyState & (MK_LBUTTON | MK_RBUTTON))){
		return DRAGDROP_S_CANCEL;
	}

	// }EX{^ꂽƂ̓hbv
	if((grfKeyState & (MK_LBUTTON | MK_RBUTTON)) == 0){
		//𓀊Jn;sŒ~
		if(DROPEFFECT_NONE!=_dwEffect){
			std::list<CString> dummyList;
			_bRet=_rModel.MakeSureItemsExtracted(_strOutputDir,_lpBase,_items,dummyList,true,_strLog);
			if(!_bRet){
				return DRAGDROP_S_CANCEL;
			}
		}
		return DRAGDROP_S_DROP;
	}
	return S_OK;
}

HRESULT __stdcall CDropSource::QueryInterface(const IID& iid, void** ppv)
{
	HRESULT hr;

	if(iid == IID_IDropSource || iid == IID_IUnknown){
		hr = S_OK;
		*ppv = (void*)this;
		AddRef();
	}else{
		hr = E_NOINTERFACE;
		*ppv = 0;
	}
	return hr;
}


ULONG __stdcall CDropSource::AddRef()
{
	InterlockedIncrement(&_RefCount);
	return (ULONG)_RefCount;
}


ULONG __stdcall CDropSource::Release()
{
	ULONG ret = (ULONG)InterlockedDecrement(&_RefCount);
	if(ret == 0){
		delete this;
	}
	return (ULONG)_RefCount;
}

HRESULT __stdcall CDropSource::GiveFeedback(DWORD dwEffect)
{
	_dwEffect=dwEffect;
	/* }EXJ[\ςAʂȕ\Ƃ͂ōs */

	//W̃}EXJ[\g
	return DRAGDROP_S_USEDEFAULTCURSORS;
}
