#pragma once

#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverBGA.h"
#include "../ConfigBGA.h"

//====================================
// BGA̐ݒ荀
//====================================
class CConfigDlgBGA : public CDialogImpl<CConfigDlgBGA>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigBGA	m_Config;

	CEdit			Edit_GZA_Level;
	CTrackBarCtrl	Track_GZA_Level;

	CEdit			Edit_BZA_Level;
	CTrackBarCtrl	Track_BZA_Level;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_BGA };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgBGA)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

