#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/ArchiverUNHKI.h"
#include "../ConfigUNHKI.h"

//====================================
// HKI̐ݒ荀
//====================================
class CConfigDlgHKI : public CDialogImpl<CConfigDlgHKI>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigHKI	m_Config;

	CButton			Radio_CompressLevel[HKI_COMPRESS_LEVEL_ITEM_COUNT];
	CButton			Radio_EncryptAlgorithm[HKI_ENCRYPT_ALGORITHM_ITEM_COUNT];

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_HKI };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgHKI)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

