#pragma once

class CSemaphoreLocker{
protected:
	HANDLE hSemaphore;
public:
	CSemaphoreLocker():hSemaphore(NULL){}
	virtual ~CSemaphoreLocker(){
		Release();
	}
	virtual bool Lock(LPCTSTR lpName,LONG MaxCount){	//Z}tHɂvZXԔr
		Release();
		hSemaphore=CreateSemaphore(NULL,MaxCount,MaxCount,lpName);
		if(ERROR_INVALID_HANDLE==GetLastError()){	//Z}tHmۂɎs
			hSemaphore=NULL;
			return false;
		}
		return WAIT_OBJECT_0==WaitForSingleObject(hSemaphore,INFINITE);
	}
	virtual void Release(){		//Z}tH̃bN
		if(hSemaphore){
			ReleaseSemaphore(hSemaphore,1,NULL);
			CloseHandle(hSemaphore);
			hSemaphore=NULL;
		}
	}
};
